support for multilevel kcms
ClosedPublic

Authored by mart on Aug 3 2018, 3:01 PM.

Details

Summary

Make the title a toolbutton, and when there are multiple levels, make
a breadcrumb out of buttons.
clicking on buttons will navigate the levels(keyboard shortcuts work too)

a similar modification will be needed to be done to KCMShell
depends from D14580

Test Plan

Added a level to a kcm, works as intended
This latest version works correctly on both the sidebar and icongrid systemsettings mode

Diff Detail

Repository
R124 System Settings
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
mart created this revision.Aug 3 2018, 3:01 PM
Restricted Application added a project: Plasma. · View Herald TranscriptAug 3 2018, 3:01 PM
Restricted Application added a subscriber: plasma-devel. · View Herald Transcript
mart requested review of this revision.Aug 3 2018, 3:01 PM
mart added a comment.EditedAug 3 2018, 3:04 PM

multi level kcm in action

mart added a reviewer: VDG.Aug 3 2018, 3:04 PM
mart updated this revision to Diff 39312.Aug 8 2018, 1:43 PM

new approach: modules paint themselves

mart retitled this revision from e a breadcrumb for multilevel kcms to support for multilevel kcms.Aug 8 2018, 1:44 PM
mart edited the summary of this revision. (Show Details)
abetts added a subscriber: abetts.Aug 8 2018, 2:03 PM

Looking great!

mart updated this revision to Diff 40502.Aug 27 2018, 12:16 PM
  • use the new api KPageWidgetItem::setHeaderVisible
mart edited the test plan for this revision. (Show Details)Aug 27 2018, 12:17 PM
davidedmundson added inline comments.
core/ModuleView.cpp
178

why?

222

we could add a property on KCModule that KCModuleQml sets

mart updated this revision to Diff 40627.Aug 29 2018, 9:43 AM
  • remove old remains of extra layouts
davidedmundson accepted this revision.Aug 29 2018, 10:42 AM
This revision is now accepted and ready to land.Aug 29 2018, 10:42 AM
This revision was automatically updated to reflect the committed changes.